/*
 * BinaerUhr.c
 *
 * Created: 21.11.2012 15:17:14
 *  Author: Coco
 */ 

#include "BinaerUhr.h"
void init_Interrupt(void);
void ds1307_init();



int main(void)
{
	init_IO();//setzen der Ausgnge fr die LEDS, LED-Select Signale, Pullup fr Interrupts und des TWI
	init_Interrupt();	//setzen des INT0
	i2c_init();
	ds1307_init(); //initialierung des Interrupts
	//nicht Erfolreich
	
	sei();	
	//test Zeit: 20:32:52
	//Test Erfolgreich.
	time.hour = 20;
	time.minute = 32;
	time.second = 52;
	while(1)
    {
        set_Time(time);
    }
}
void init_Interrupt(void)
{
	EICRA |= _bv(ISC00) | _bv(ISC01);
	EIMSK |= _bv(INT0);
}
void init_IO(void)
{
	DDRD	= _bv(LED0) | _bv(LED1) | _bv(LED1) | _bv(LED3) | _bv(LED4) | _bv(LED5) | _bv(LED6);
	DDRB	= _bv(LEDSEL_HOUR) | _bv(LEDSEL_MIN) | _bv(LEDSEL_SEC) | _bv(LED_DIMMER);
	PORTC	= _bv(PINC4) | _bv(PINC5);  //SDA und SCL
	PORTD	= _bv(PIND2);				// Pullup fr INT0
}
void set_LED(uint8_t bitmask)
{
	LEDPORT = (0x03 & bitmask) | ((0xFC & bitmask)<<1); //verschieben um 1 da port3 anderweitig verwendet wird
}
void set_Time(volatile struct time_t zeit)
{
	LEDSELPORT |= _bv(LED_DIMMER);	
	
	set_LED(0x00);
	LEDSELPORT ^= _bv(LEDSEL_HOUR);
	set_LED(zeit.hour);	
	_delay_ms(LEDDELAY);
	LEDSELPORT &= ~_bv(LEDSEL_HOUR);
	
	set_LED(0x00);
	LEDSELPORT ^= _bv(LEDSEL_MIN);	
	set_LED(zeit.minute);
	_delay_ms(LEDDELAY);
	LEDSELPORT &= ~_bv(LEDSEL_MIN);
	
	set_LED(0x00);
	LEDSELPORT ^= _bv(LEDSEL_SEC);	
	set_LED(zeit.second);	
	_delay_ms(LEDDELAY);
	LEDSELPORT &= ~_bv(LEDSEL_SEC);
	
	LEDSELPORT &= ~_bv(LED_DIMMER);	
}
void set_LED_debug(uint8_t bitmask)
{
	LEDSELPORT |= _bv(LED_DIMMER);	
	
	LEDPORT = (0x03 & bitmask) | ((0xFC & bitmask)<<1);
	LEDSELPORT |= _bv(LEDSEL_HOUR);
	LEDPORT = (0x03 & bitmask) | ((0xFC & bitmask)<<1);
}
ISR(INT0_vect)
{
	if(time.second<60)
	{
		time.second++;
	}
	else
	{
		time.second = 0;
		time.minute ++;
	}
	
}
void ds1307_init()
{
  /* Tell the DS1307 to start the oscillator (turn off CLOCK HALT) in
   * case it has lost power. */
    uint8_t reg0;
set_LED_debug(0x01);
  /* Address, say read from memory slot 0, then read data. */
    
	i2c_start_wait(DS1307+I2C_WRITE);	
set_LED_debug(0x02);
	
    i2c_write(0x00);
set_LED_debug(0x03);
    
	i2c_rep_start(DS1307+I2C_READ);
    reg0=i2c_readNak();
set_LED_debug(0x04);

  /* Turn off the clock halt if necessary. */
  if(reg0 & _BV(CLOCK_HALT)) {
	  
    i2c_start_wait(DS1307+I2C_WRITE);
set_LED_debug(0x05);
    i2c_write(0x00);
set_LED_debug(0x06);
    i2c_write(reg0 & ~_BV(CLOCK_HALT));
set_LED_debug(0x07);
  }

  /* Fire up the 1Hz interrupt. */
  
    i2c_start_wait(DS1307+I2C_WRITE);
set_LED_debug(0x08);
    i2c_write(SQW_CONTROL_REG);
set_LED_debug(0x09);
    i2c_write(_BV(SQW_SQWE) | SQW_RS1_RS0_1Hz);
set_LED_debug(0x10);
  

  i2c_stop();
}