/*
 * BinaerUhr.h
 *
 * Created: 21.11.2012 16:00:25
 *  Author: Coco
 */ 


#ifndef BINAERUHR_H_
#define BINAERUHR_H_

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#include "twi/i2cmaster.h"


#define _bv(bit) (1<<bit)


#define LEDPORT PORTD
#define LED0 PORTD0
#define LED1 PORTD1
#define LED2 PORTD2
#define LED3 PORTD3
#define LED4 PORTD4
#define LED5 PORTD5
#define LED6 PORTD6

#define LEDSELPORT PORTB
#define LEDSEL_HOUR PORTB1
#define LEDSEL_MIN PORTB7
#define LEDSEL_SEC PORTB6
#define LED_DIMMER PORTB2

#define LEDDELAY 5  // zeit in ms die beim Multiplexen vertrdelt wird

#define DS1307 0xD0
#define CLOCK_HALT   7
#define SQW_CONTROL_REG 0x07

#define SQW_OUT         7
#define SQW_SQWE        4
#define SQW_RS1_RS0_1Hz 0x00

volatile struct time_t {
	uint8_t hour,minute,second;
	uint8_t day,month,year;
}time;


void set_LED(uint8_t bitmask);
void init_IO(void);
void set_Time(volatile struct time_t zeit);
void set_LED_debug(uint8_t bitmask);


#endif /* BINAERUHR_H_ */